unit BugSrvcUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, SvcMgr, Dialogs,
  BUGSvcThreadUnit;

type
  TBugService = class(TService)
    procedure ServiceStart(Sender: TService; var Started: Boolean);
    procedure ServiceStop(Sender: TService; var Stopped: Boolean);
    procedure ServicePause(Sender: TService; var Paused: Boolean);
    procedure ServiceContinue(Sender: TService; var Continued: Boolean);
  private
    { Private declarations }
    FSvcThread: TSvcThread;
  public
    function GetServiceController: TServiceController; override;
    { Public declarations }
  end;

var
  BugService: TBugService;

implementation

{$R *.DFM}

procedure ServiceController(CtrlCode: DWord); stdcall;
begin
  BugService.Controller(CtrlCode);
end;

function TBugService.GetServiceController: TServiceController;
begin
  Result := ServiceController;
end;

procedure TBugService.ServiceStart(Sender: TService; var Started: Boolean);
begin
  FSvcThread := TSvcThread.Create (False);
  Started := True;
end;

procedure TBugService.ServiceStop(Sender: TService; var Stopped: Boolean);
begin
  FSvcThread.Terminate;
  Stopped := True;
end;

procedure TBugService.ServicePause(Sender: TService; var Paused: Boolean);
begin
  FSvcThread.Suspend;
  Paused := true;
end;

procedure TBugService.ServiceContinue(Sender: TService;
  var Continued: Boolean);
begin
  FSvcThread.Resume;
  Continued := true;
end;

end.
